#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

#define endl			'\n'

int h, w;
int n, m;
string s[2111];
int cnt[2111][2111];

int getCnt( int x1, int y1, int x2, int y2 ) {
	int ans = cnt[x2][y2];
	if( x1 )
		ans -= cnt[x1-1][y2];
	if( y1 )
		ans -= cnt[x2][y1-1];
	if( x1 && y1 )
		ans += cnt[x1-1][y1-1];
	return ans;
}

long long solve( int x1, int y1, int x2, int y2 ) {
	int X1 = ( x1 / n + 1 ) * n;
	int Y1 = ( y1 / m + 1 ) * m;
	int X2 = ( x2 / n ) * n;
	int Y2 = ( y2 / m ) * m;
	int N = ( X2 - X1 ) / n;
	int M = ( Y2 - Y1 ) / m;
	x1 %= n;
	x2 %= n;
	y1 %= m;
	y2 %= m;
	long long ans = 0;
	if( N < 0 && M < 0 ) {
		ans += getCnt( x1, y1, x2, y2 );
	} else if( N < 0 ) {
		ans += getCnt( x1, y1, x2, m-1 );
		ans += getCnt( x1, 0, x2, y2 );
	} else if( M < 0 ) {
		ans += getCnt( x1, y1, n-1, y2 );
		ans += getCnt( 0, y1, x2, y2 );
	} else {
		ans += getCnt( x1, y1, n-1, m-1 );
		ans += getCnt( x1, 0, n-1, y2 );
		ans += getCnt( 0, y1, x2, m-1 );
		ans += getCnt( 0, 0, x2, y2 );
	}
	if( N >= 0 && M >= 0 ) {
		ans += 1LL * N * getCnt( 0, y1, n-1, m-1 );
		ans += 1LL * N * getCnt( 0, 0, n-1, y2 );
		ans += 1LL * M * getCnt( x1, 0, n-1, m-1 );
		ans += 1LL * M * getCnt( 0, 0, x2, m-1 );
		ans += 1LL * N * M * getCnt( 0, 0, n-1, m-1 );
	} else if( N >= 0 ) {
		ans += 1LL * N * getCnt( 0, y1, n-1, y2 );
	} else if( M >= 0 ) {
		ans += 1LL * M * getCnt( x1, 0, x2, m-1 );
	}
	return ans;
}

int main( int argc, char *argv[] ) {
	cin.tie( 0 ); cin.sync_with_stdio( 0 );
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );
	cin >> h >> w;
	cin >> n >> m;
	for( int i = 0; i < n; i ++ ) {
		cin >> s[i];
		string c = s[i];
		reverse( c.begin(), c.end() );
		s[i] += c;
	}
	for( int i = 0, j = 2 * n - 1; i < n; i ++, j -- ) {
		s[j] = s[i];
	}
	n *= 2;
	m *= 2;
	cnt[0][0] = ( s[0][0] == 'X' );
	for( int i = 1; i < n; i ++ ) {
		cnt[i][0] = cnt[i-1][0] + ( s[i][0] == 'X' );
	}
	for( int j = 1; j < m; j ++ ) {
		cnt[0][j] = cnt[0][j-1] + ( s[0][j] == 'X' );
	}
	for( int i = 1; i < n; i ++ ) {
		for( int j = 1; j < m; j ++ ) {
			cnt[i][j] = cnt[i-1][j] + cnt[i][j-1] - cnt[i-1][j-1] + ( s[i][j] == 'X' );
		}
	}
	int q;
	cin >> q;
	for( int i = 0; i < q; i ++ ) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		x1 --, y1 --, x2 --, y2 --;
		long long ans = solve( x1, y1, x2, y2 );
		cout << ans << endl;
	}
	return 0;
}
